;--------------------------------------------
;mc_neutroni_examples.pro
;--------------------------------------------
;syksy 2007 simulaatiokurssi (HS)
;neutronien ampuminen levyyn
;vertaa eri menetelmien antamia tuloksia

;menetelma
;1 neutronin rata paattyy absorbtioon, heijastukseen tai lapaisyyn
;2 painomenetelma: absorbtio otetaan huomioon painoa pienentamalla
;                  rata paattyy heijastukseen tai lapaisyyn
;3 painometelma: jokainen ratasegmentti pakotetaan sirontaa
;                absorbtio, heijatus ja lapaisy otetaan huomioon
;                painoa pienetamalla
;                



htab=(findgen(10)+1)*.5
alb=0.1

N=100

nh=n_elements(htab)


;talletetaan tulokset kaikilla kolmella menetelmalla
   p_lap_tab=fltarr(nh,3)
   p_abs_tab=fltarr(nh,3)
   p_hei_tab=fltarr(nh,3)
   dp_lap_tab=fltarr(nh,3)
   dp_abs_tab=fltarr(nh,3)
   dp_hei_tab=fltarr(nh,3)


   for i=0,nh-1 do begin
      h=htab(i)
           

for j=0,2 do begin 

;siirretaaan hieman pisteita
dh=(htab(1)-htab(0))*0.1*(j-1)
h=htab(i)+dh

print,'h='+string(h)+'   method='+string(j+1)

   if(j eq 0) then begin
      mc_neutroni_method1_f,$
         h,alb,n, p_lap,p_abs,p_hei, dp_lap,dp_abs,dp_hei,seed=seed
   endif

   if(j eq 1) then begin
      mc_neutroni_method2_f,$
         h,alb,n, p_lap,p_abs,p_hei, dp_lap,dp_abs,dp_hei,seed=seed
   endif

   if(j eq 2) then begin
      mc_neutroni_method3_f,$
         h,alb,n, p_lap,p_abs,p_hei, dp_lap,dp_abs,dp_hei,seed=seed
   endif

      p_lap_tab(i,j)=p_lap
      p_abs_tab(i,j)=p_abs
      p_hei_tab(i,j)=p_hei
      dp_lap_tab(i,j)=dp_lap
      dp_abs_tab(i,j)=dp_abs
      dp_hei_tab(i,j)=dp_hei
   endfor
endfor
   

title='ALB='+string(alb,'(f6.4)')+'  N='+string(N,'(i6)')


nwin
for j=0,2 do begin
   if(j eq 0) then begin
      plot,htab,p_lap_tab(*,j),yr=[0,1.4],ys=1,title=title,xtitle='H',ytitle='p',/nod
   endif

;varit
!p.color=j+2
;siirretaaan hieman pisteita
dh=(htab(1)-htab(0))*0.1*(j-1)

if(j eq 0) then !psym=-6
if(j eq 1) then !psym=-4
if(j eq 2) then !psym=-5

oplot,dh+htab,p_lap_tab(*,j),col=j+2
oploterr,dh+htab,p_lap_tab(*,j),dp_lap_tab(*,j)

oplot,dh+htab,p_hei_tab(*,j),col=j+2,lines=2
oploterr,dh+htab,p_hei_tab(*,j),dp_lap_tab(*,j)

oplot,dh+htab,p_abs_tab(*,j),col=j+2,lines=1
oploterr,dh+htab,p_abs_tab(*,j),dp_lap_tab(*,j)

endfor


label_data,0.1,0.9,['LAPAISY','HEIJASTUS','ABSORBTIO'],lines=[0,2,1],col=[5,5,5]

label_data,0.5,0.9,['MET 1','MET 2',' MET3'],lines=[0,0,0],col=[2,3,4],len=0.00005,psym=[6,4,5]
!p.color=255
!psym=0
plot_stamp,'mc_neutroni_examples'





end


